diff --git a/src/Castle.Core.Tests/BugsReported/ConstraintViolationInDebuggerTestCase.cs b/src/Castle.Core.Tests/BugsReported/ConstraintViolationInDebuggerTestCase.cs
index 54db5bd..52cfa1a 100644
--- a/src/Castle.Core.Tests/BugsReported/ConstraintViolationInDebuggerTestCase.cs
+++ b/src/Castle.Core.Tests/BugsReported/ConstraintViolationInDebuggerTestCase.cs
@@ -1,92 +1,89 @@
-// Copyright 2004-2010 Castle Project - http://www.castleproject.org/
-// 
-// Licensed under the Apache License, Version 2.0 (the "License");
-// you may not use this file except in compliance with the License.
-// You may obtain a copy of the License at
-// 
-//     http://www.apache.org/licenses/LICENSE-2.0
-// 
-// Unless required by applicable law or agreed to in writing, software
-// distributed under the License is distributed on an "AS IS" BASIS,
-// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-// See the License for the specific language governing permissions and
-// limitations under the License.
-
-namespace Castle.DynamicProxy.Tests.BugsReported
-{
-	using System;
-
-	using NUnit.Framework;
-
-	[TestFixture]
-	public class ConstraintViolationInDebuggerTestCase : BasePEVerifyTestCase
-	{
-		// This test case yields a TypeLoadException in the debugger, but works perfectly without a debugger attached.
-		// It also produces verifiable code.
-		// In Visual Studio 2010 this test passes just fine with the debugger attached.
-		[Test]
-#if __MonoCS__
-		[Ignore("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-#endif
-		public void TestCase()
-		{
-			generator.ProxyBuilder.CreateInterfaceProxyTypeWithTarget(
-				typeof (IPresentationHost), Type.EmptyTypes, typeof (PresentationHost), ProxyGenerationOptions.Default);
-
-			IServiceAgent agent =
-				(IServiceAgent)
-				generator.CreateInterfaceProxyWithTarget<IServiceAgent>(new ServiceAgent(), new StandardInterceptor());
-			agent.GetProxy<string>();
-		}
-
-		public class PresentationHost : IPresentationHost
-		{
-			#region IPresentationHost Members
-
-			public void Register<T>() where T : IPresentation
-			{
-			}
-
-			public void Register<T>(Type service) where T : IPresentation
-			{
-			}
-
-			#endregion
-		}
-
-		public class ServiceAgent : IServiceAgent
-		{
-			#region IServiceAgent Members
-
-			public T GetProxy<T>() where T : class
-			{
-				return null;
-			}
-
-			public T GetProxy<T>(object callbackInstance) where T : class
-			{
-				return null;
-			}
-
-			#endregion
-		}
-
-
-		public interface IPresentationHost
-		{
-			void Register<T>() where T : IPresentation;
-			void Register<T>(Type service) where T : IPresentation;
-		}
-
-		public interface IServiceAgent
-		{
-			T GetProxy<T>() where T : class;
-			T GetProxy<T>(object callbackInstance) where T : class;
-		}
-
-
-		public interface IPresentation
-		{
-		}
-	}
+// Copyright 2004-2010 Castle Project - http://www.castleproject.org/
+// 
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+// 
+//     http://www.apache.org/licenses/LICENSE-2.0
+// 
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+namespace Castle.DynamicProxy.Tests.BugsReported
+{
+	using System;
+
+	using NUnit.Framework;
+
+	[TestFixture]
+	public class ConstraintViolationInDebuggerTestCase : BasePEVerifyTestCase
+	{
+		// This test case yields a TypeLoadException in the debugger, but works perfectly without a debugger attached.
+		// It also produces verifiable code.
+		// In Visual Studio 2010 this test passes just fine with the debugger attached.
+		[Test]
+		public void TestCase()
+		{
+			generator.ProxyBuilder.CreateInterfaceProxyTypeWithTarget(
+				typeof (IPresentationHost), Type.EmptyTypes, typeof (PresentationHost), ProxyGenerationOptions.Default);
+
+			IServiceAgent agent =
+				(IServiceAgent)
+				generator.CreateInterfaceProxyWithTarget<IServiceAgent>(new ServiceAgent(), new StandardInterceptor());
+			agent.GetProxy<string>();
+		}
+
+		public class PresentationHost : IPresentationHost
+		{
+			#region IPresentationHost Members
+
+			public void Register<T>() where T : IPresentation
+			{
+			}
+
+			public void Register<T>(Type service) where T : IPresentation
+			{
+			}
+
+			#endregion
+		}
+
+		public class ServiceAgent : IServiceAgent
+		{
+			#region IServiceAgent Members
+
+			public T GetProxy<T>() where T : class
+			{
+				return null;
+			}
+
+			public T GetProxy<T>(object callbackInstance) where T : class
+			{
+				return null;
+			}
+
+			#endregion
+		}
+
+
+		public interface IPresentationHost
+		{
+			void Register<T>() where T : IPresentation;
+			void Register<T>(Type service) where T : IPresentation;
+		}
+
+		public interface IServiceAgent
+		{
+			T GetProxy<T>() where T : class;
+			T GetProxy<T>(object callbackInstance) where T : class;
+		}
+
+
+		public interface IPresentation
+		{
+		}
+	}
 }
\ No newline at end of file
diff --git a/src/Castle.Core.Tests/DynamicProxy.Tests/ClassProxyWithDefaultValuesTestCase.cs b/src/Castle.Core.Tests/DynamicProxy.Tests/ClassProxyWithDefaultValuesTestCase.cs
index 16fd345..fe505b7 100644
--- a/src/Castle.Core.Tests/DynamicProxy.Tests/ClassProxyWithDefaultValuesTestCase.cs
+++ b/src/Castle.Core.Tests/DynamicProxy.Tests/ClassProxyWithDefaultValuesTestCase.cs
@@ -1,80 +1,72 @@
-// Copyright 2004-2013 Castle Project - http://www.castleproject.org/
-// 
-// Licensed under the Apache License, Version 2.0 (the "License");
-// you may not use this file except in compliance with the License.
-// You may obtain a copy of the License at
-// 
-//     http://www.apache.org/licenses/LICENSE-2.0
-// 
-// Unless required by applicable law or agreed to in writing, software
-// distributed under the License is distributed on an "AS IS" BASIS,
-// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-// See the License for the specific language governing permissions and
-// limitations under the License.
-
-namespace Castle.DynamicProxy.Tests
-{
-	using System.Linq;
-
-	using Castle.DynamicProxy.Tests.Classes;
-	using Castle.DynamicProxy.Tests.Interceptors;
-
-	using CastleTests.DynamicProxy.Tests.Classes;
-	using CastleTests.DynamicProxy.Tests.Interfaces;
-
-	using NUnit.Framework;
-
-	[TestFixture]
-	public class ClassProxyWithDefaultValuesTestCase : BasePEVerifyTestCase
-	{
-#if DOTNET45
-		[Test]
-#if __MonoCS__
-		// Seems like mono is too strict, and doesn't handle a nullable default parameter in ParameterBuilder
-		// https://github.com/mono/mono/blob/master/mcs/class/corlib/System.Reflection.Emit/ParameterBuilder.cs#L101
-		[Ignore("System.ArgumentException : Constant does not match the defined type.")]
-#endif
-		public void MethodParameterWithDefaultValue_DefaultValueIsSetOnProxiedMethodAsWell()
-		{
-			var proxiedType = generator.CreateClassProxy<ClassWithMethodWithParameterWithDefaultValue>().GetType();
-
-			var parameter = proxiedType.GetMethod("Method").GetParameters().Single(paramInfo => paramInfo.Name == "value");
-
-			Assert.True(parameter.HasDefaultValue);
-			Assert.AreEqual(3, parameter.DefaultValue);
-		}
-
-		[Test]
-#if __MonoCS__
-		[Ignore("Expected: False  But was: True")]
-#endif
-		public void MethodParameterWithDefaultValue_DefaultValueNullIsSetOnProxiedMethodAsWell()
-		{
-			var proxiedType = generator.CreateClassProxy<ClassWithMethodWithParameterWithNullDefaultValue>().GetType();
-
-			var parameter = proxiedType.GetMethod("Method").GetParameters().Single(paramInfo => paramInfo.Name == "value");
-
-			Assert.False(parameter.HasDefaultValue);
-		}
-
-		[Test]
-		public void MethodParameterWithDefaultValue_UseNullDefaultValue_class_proxy()
-		{
-			var proxy = generator.CreateClassProxy<ClassWithMethodWithParameterWithNullDefaultValue>();
-			var result = proxy.Method();
-
-			Assert.IsTrue(result);
-		}
-
-		[Test]
-		public void MethodParameterWithDefaultValue_UseNullDefaultValue_interface_proxy()
-		{
-			var proxy = generator.CreateInterfaceProxyWithoutTarget<InterfaceWithMethodWithParameterWithNullDefaultValue>(
-					new SetReturnValueInterceptor(true));
-			var result = proxy.Method();
-
-			Assert.IsTrue(result);
-		}
-#endif
-	}
+// Copyright 2004-2013 Castle Project - http://www.castleproject.org/
+// 
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+// 
+//     http://www.apache.org/licenses/LICENSE-2.0
+// 
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+namespace Castle.DynamicProxy.Tests
+{
+	using System.Linq;
+
+	using Castle.DynamicProxy.Tests.Classes;
+	using Castle.DynamicProxy.Tests.Interceptors;
+
+	using CastleTests.DynamicProxy.Tests.Classes;
+	using CastleTests.DynamicProxy.Tests.Interfaces;
+
+	using NUnit.Framework;
+
+	[TestFixture]
+	public class ClassProxyWithDefaultValuesTestCase : BasePEVerifyTestCase
+	{
+#if DOTNET45 && !__MonoCS__ // dotnet45 allows passing default parameter value to proxy, mono as earlier .net version do not
+		[Test]
+		public void MethodParameterWithDefaultValue_DefaultValueIsSetOnProxiedMethodAsWell()
+		{
+			var proxiedType = generator.CreateClassProxy<ClassWithMethodWithParameterWithDefaultValue>().GetType();
+
+			var parameter = proxiedType.GetMethod("Method").GetParameters().Single(paramInfo => paramInfo.Name == "value");
+
+			Assert.True(parameter.HasDefaultValue);
+			Assert.AreEqual(3, parameter.DefaultValue);
+		}
+
+		[Test]
+		public void MethodParameterWithDefaultValue_DefaultValueNullIsSetOnProxiedMethodAsWell()
+		{
+			var proxiedType = generator.CreateClassProxy<ClassWithMethodWithParameterWithNullDefaultValue>().GetType();
+
+			var parameter = proxiedType.GetMethod("Method").GetParameters().Single(paramInfo => paramInfo.Name == "value");
+
+			Assert.False(parameter.HasDefaultValue);
+		}
+
+		[Test]
+		public void MethodParameterWithDefaultValue_UseNullDefaultValue_class_proxy()
+		{
+			var proxy = generator.CreateClassProxy<ClassWithMethodWithParameterWithNullDefaultValue>();
+			var result = proxy.Method();
+
+			Assert.IsTrue(result);
+		}
+
+		[Test]
+		public void MethodParameterWithDefaultValue_UseNullDefaultValue_interface_proxy()
+		{
+			var proxy = generator.CreateInterfaceProxyWithoutTarget<InterfaceWithMethodWithParameterWithNullDefaultValue>(
+					new SetReturnValueInterceptor(true));
+			var result = proxy.Method();
+
+			Assert.IsTrue(result);
+		}
+#endif
+	}
 }
\ No newline at end of file
diff --git a/src/Castle.Core.Tests/DynamicProxy.Tests/InterfaceProxyWithMethodsWithOptionalParametersTestCase.cs b/src/Castle.Core.Tests/DynamicProxy.Tests/InterfaceProxyWithMethodsWithOptionalParametersTestCase.cs
index bd05f79..b7fe391 100644
--- a/src/Castle.Core.Tests/DynamicProxy.Tests/InterfaceProxyWithMethodsWithOptionalParametersTestCase.cs
+++ b/src/Castle.Core.Tests/DynamicProxy.Tests/InterfaceProxyWithMethodsWithOptionalParametersTestCase.cs
@@ -1,38 +1,33 @@
-ï»¿// Copyright 2004-2015 Castle Project - http://www.castleproject.org/
-// 
-// Licensed under the Apache License, Version 2.0 (the "License");
-// you may not use this file except in compliance with the License.
-// You may obtain a copy of the License at
-// 
-//     http://www.apache.org/licenses/LICENSE-2.0
-// 
-// Unless required by applicable law or agreed to in writing, software
-// distributed under the License is distributed on an "AS IS" BASIS,
-// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-// See the License for the specific language governing permissions and
-// limitations under the License.
-
-#if !DOTNET35 && !SILVERLIGHT
-namespace Castle.DynamicProxy.Tests
-{
-	using CastleTests.DynamicProxy.Tests.Interfaces;
-
-	using NUnit.Framework;
-
-	[TestFixture]
-	public class InterfaceProxyWithMethodsWithOptionalParametersTestCase
-	{
-		[Test]
-#if __MonoCS__
-		// Seems like mono is too strict, and doesn't handle a nullable default parameter in ParameterBuilder
-		// https://github.com/mono/mono/blob/master/mcs/class/corlib/System.Reflection.Emit/ParameterBuilder.cs#L101
-		[Ignore("System.ArgumentException : Constant does not match the defined type.")]
-#endif
-		public void CanCreateInterfaceProxy()
-		{
-			var proxyGenerator = new ProxyGenerator();
-			proxyGenerator.CreateInterfaceProxyWithoutTarget<InterfaceWithMethodsWithAllKindsOfOptionalParameters>();
-		}
-	}
-}
+ï»¿// Copyright 2004-2015 Castle Project - http://www.castleproject.org/
+// 
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+// 
+//     http://www.apache.org/licenses/LICENSE-2.0
+// 
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+#if !DOTNET35 && !SILVERLIGHT
+namespace Castle.DynamicProxy.Tests
+{
+	using CastleTests.DynamicProxy.Tests.Interfaces;
+
+	using NUnit.Framework;
+
+	[TestFixture]
+	public class InterfaceProxyWithMethodsWithOptionalParametersTestCase
+	{
+		[Test]
+		public void CanCreateInterfaceProxy()
+		{
+			var proxyGenerator = new ProxyGenerator();
+			proxyGenerator.CreateInterfaceProxyWithoutTarget<InterfaceWithMethodsWithAllKindsOfOptionalParameters>();
+		}
+	}
+}
 #endif
\ No newline at end of file
diff --git a/src/Castle.Core.Tests/GenericClassProxyTestCase.cs b/src/Castle.Core.Tests/GenericClassProxyTestCase.cs
index da325cb..8fa9056 100644
--- a/src/Castle.Core.Tests/GenericClassProxyTestCase.cs
+++ b/src/Castle.Core.Tests/GenericClassProxyTestCase.cs
@@ -114,8 +114,9 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-		//		[Platform(Exclude = "mono", Reason = "Assertion at sgen-alloc.c:460, condition `*p == NULL' not met. " +
-//			"Fixed in https://bugzilla.xamarin.com/show_bug.cgi?id=28182")]
+#if __MonoCS__
+		[Ignore ("System.Type.GetTypeInfo().IsByRef throws a System.InvalidCastException on mono 4.0.2")]
+#endif
 		public void ProxyWithMethodReturningGenericOfGenericOfT ()
 		{
 			var proxy = generator.CreateClassProxy<ClassWithMethodWithReturnArrayOfListOfT> ();
@@ -124,9 +125,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void ProxyWithGenericArgumentsAndMethodGenericArguments ()
 		{
 			GenClassWithGenMethods<List<object>> proxy =
@@ -142,9 +140,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void ProxyWithGenericArgumentsAndMethodGenericArgumentsWithConstraints ()
 		{
 			GenClassWithGenMethodsConstrained<List<object>> proxy =
@@ -160,9 +155,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void ProxyWithGenericArgumentsAndMethodGenericArgumentsWithOneNotDefinedOnType ()
 		{
 			GenClassWithGenMethods<List<object>> proxy =
@@ -214,9 +206,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void ClassWithGenMethodOnly ()
 		{
 			OnlyGenMethodsClass proxy =
@@ -231,9 +220,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void MethodInfoClosedInGenTypeGenMethodRefType ()
 		{
 			KeepDataInterceptor interceptor = new KeepDataInterceptor ();
@@ -249,9 +235,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void MethodInfoClosedInGenTypeGenMethodValueType ()
 		{
 			KeepDataInterceptor interceptor = new KeepDataInterceptor ();
@@ -315,9 +298,6 @@ namespace Castle.DynamicProxy.Tests
 		}
 
 		[Test]
-#if __MonoCS__
-		[Ignore ("System.Type[] doesn't implement interface Castle.DynamicProxy.IInvocation")]
-		#endif
 		public void MethodInfoClosedInNongenTypeGenMethod ()
 		{
 			KeepDataInterceptor interceptor = new KeepDataInterceptor ();
